* Run the Suduko game

PRIVATE goApp
LOCAL cGameFile, lIsJigsaw

goApp = CREATEOBJECT("SudokuApp")
cGameFile = GETFILE("txt", "Game:", "Open", 0 , "Choose game")

* If the name contains "jigsaw", 
* use the jigsaw classes.
* If we wanted to handle a variety of variant types,
* the best bet would be to pass a string indicating
* the variant type, and then have a metadata table
* to look up the class to use for each.
lIsJigsaw = "JIGSAW"$UPPER(m.cGameFile)

goApp.SetupGame(m.cGameFile, m.lIsJigsaw)

goApp.DisplayGame(m.lIsJigsaw)

READ events

RETURN

DEFINE CLASS SudokuApp AS Custom

oGame = .null. 
oForm = .null.

PROCEDURE SetupGame(cGameFile, lIsJigsaw)

IF m.lIsJigsaw
	This.oGame = NEWOBJECT("bizgamejigsaw", "bizobjs")
ELSE 
	This.oGame = NEWOBJECT("bizGame", "bizobjs")
ENDIF 

This.oGame.NewGame(m.cGameFile)

RETURN
ENDPROC


PROCEDURE DisplayGame(lIsJigsaw)

IF m.lIsJigsaw
	This.oForm = NEWOBJECT("frmSudoku", "forms.vcx")	
ELSE 
	This.oForm = NEWOBJECT("frmSudoku", "forms.vcx")
ENDIF 
This.oForm.oBizGame = This.oGame
This.oForm.BuildBoard(lIsJigsaw)
This.oForm.Show()

RETURN
ENDPROC

ENDDEFINE
